#include <lpc11xx.h>
#include "at24c16.h"
#include "i2c.h"
#include "systick_delay.h"

/*********************************************/
/* ܣAT24C16дһֽ       */
/* ڲWriteAddr:ҪдĿַ    */
/*           DataToWrite:Ҫдֽ  */
/* ע⣺AT24C16ĵַΪ0x0000~0x07FF    */
/*********************************************/
void AT24C16_WriteOneByte(uint16_t WriteAddr, uint8_t DataToWrite)
{				  
    I2C_Send_Ctrl(0XA0+((WriteAddr/256)<<1)); //͸λַ	  
	I2C_Send_Byte(WriteAddr%256);	 //͵͵ַ 										  		   
	I2C_Send_Byte(DataToWrite);     //ֽ							   		    	   
    I2C_Stop();//һֹͣ 
	delay_ms(5);// ʱԲȥ	 
}

/*********************************************/
/* ܣAT24C16жһֽ       */
/* ڲtemp :                */
/* ע⣺AT24C16ĵַΪ0x0000~0x07FF    */
/*********************************************/
uint8_t AT24C16_ReadOneByte(uint16_t ReadAddr)
{				  
	uint8_t temp=0;
			  	    																 
	I2C_Send_Ctrl(0XA0+((ReadAddr/256)<<1)); 	 
    I2C_Send_Byte(ReadAddr%256);   //͵͵ַ    	 	   
	I2C_Send_Ctrl(0XA1+((ReadAddr/256)<<1));			   
    temp=I2C_Recieve_Byte();	   
    I2C_Stop();//һֹͣ
		    
	return temp;
}

/*********************************************/
/* ܣAT24C16жֽ       */
/* ڲReadAddr:ҪݵĿַ   */
/*           *Buffer:ŵ  */
/*           NumҪֽڸ         */
/* ע⣺AT24C16ĵַΪ0x0000~0x07FF    */
/*********************************************/
void AT24C16_Read(uint16_t ReadAddr,uint8_t *Buffer,uint16_t Num)
{
	while(Num)
	{
		*Buffer++=AT24C16_ReadOneByte(ReadAddr++);	
		Num--;
	}
}  

/*********************************************/
/* ܣAT24C16дֽ       */
/* ڲWriteAddr:ҪдݵĿַ  */
/*           *Buffer:ед  */
/*           NumҪдֽڸ         */
/* ע⣺AT24C16ĵַΪ0x0000~0x07FF    */
/*********************************************/
void AT24C16_Write(uint16_t WriteAddr,uint8_t *Buffer,uint16_t Num)
{
	while(Num--)
	{
		AT24C16_WriteOneByte(WriteAddr,*Buffer);
		WriteAddr++;
		Buffer++;
	}
}

/***********************************************/
/* ܣAT24C16Ƿ               */
/* ڲ0                           */
/*           1                         */
/***********************************************/
uint8_t AT24C16_Check(void)
{
	uint8_t temp;
	temp = AT24C16_ReadOneByte(0x0000);	 // ֽ		   
	if(temp==0x88)
        return 0;		   
	else//ųһγʼ
	{
		AT24C16_WriteOneByte(0x0000,0x88);
	    temp=AT24C16_ReadOneByte(0x0000);	  
		if(temp==0X88)
            return 0;
	}
	return 1;											  
}








