#ifndef __DS18B20_H
#define __DS18B20_H

#include <lpc11xx.h>
#include "gpio.h"


	

#define SET_DQ()        GPIOSetDir(PORT0,7,OUT);   \
						GPIOSetValue(PORT0,7,HIGH);
#define CLR_DQ()        GPIOSetDir(PORT0,7,OUT);   \
						GPIOSetValue(PORT0,7,LOW);
#define GET_DQ()        ((1<<7) == (LPC_GPIO0->DATA & (1<<7)))

void Onewire_Enable_GPIO_Port(void);
void Onewire_OUT_PULL_UP(void);
//void Onewire_OUT_FLOATING(void);
//void Onewire_IN_FLOATING(void);
void Onewire_IN_PULL_UP(void);
void resetOnewire(void) ;
uint8_t rOnewire(void);
void wOnewire(uint8_t data);
void OneWire_Test(void);

void convertDs18b20(void);
uint8_t* readID(void);
uint32_t readTemp(void);

#endif /*_18B20_H*/

