#include "i2c.h"

/****************************************/
/* ܣʼLPC1114 I2Cģ      */
/* ڲMode :0 , ģʽ         */
/*                 1 , ģʽ         */
/****************************************/
void I2C_Init(uint8_t Mode)
{
	LPC_SYSCON->PRESETCTRL |= (1<<1); // De-asserted I2Cģ飨I2Cģ֮ǰλд1
 	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<5); // ʹI2Cʱ
	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<16); // ʹIOCONʱ
  	LPC_IOCON->PIO0_4 &= ~0x3F;	    
  	LPC_IOCON->PIO0_4 |= 0x01;		// P0.4Ϊ I2C SCL 
  	LPC_IOCON->PIO0_5 &= ~0x3F;	
  	LPC_IOCON->PIO0_5 |= 0x01;		// P0.5Ϊ I2C SDA 
	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<16); // IOCONʱ 
   	if(Mode == 1)	// I2Cͨ (Լ400KHz)AT24C16֧400Kģʽ
   	{
      	LPC_I2C->SCLH = 47;  // 0.8us
     	LPC_I2C->SCLL = 93;  // 1.4us
   	}
   	else 	// I2Cͨ	 (Լ100KHz)
   	{
      	LPC_I2C->SCLH = 47*4; // 3.2us
      	LPC_I2C->SCLL = 93*4; // 5.6us
   	}
   	LPC_I2C->CONCLR = 0xFF;  // б־
   	LPC_I2C->CONSET |= I2CONSET_I2EN;  // ʹI2Cӿ
}

/***************************************************/
/* ܣֹͣź                          */
/***************************************************/
void I2C_Stop(void)
{
   LPC_I2C->CONCLR = I2CONCLR_SIC;    // SI־λ
   LPC_I2C->CONSET |= I2CONSET_STO; 	// ֹͣź
}

/***************************************************/
/* ܣI2C                       */
/* ڲCtrl : +ַֽ                  */
/* ڲ0ɹ                               */
/*           1: ʧ                               */
/***************************************************/
uint8_t I2C_Send_Ctrl(uint8_t CtrlAndAddr)
{
   	uint8_t res;

   	if(CtrlAndAddr & 1)    // Ƕ
   	   	res = 0x40; // 40HʼźźͶѾϣѾյACK
   	else			   // д
       	res = 0x18; // 18HʼźźдѾϣѾյACK
	// Ϳʼź
   	LPC_I2C->CONCLR = 0xFF; // б־λ
   	LPC_I2C->CONSET |= I2CONSET_I2EN | I2CONSET_STA;	// ʹܷͿʼź
   	while(!(LPC_I2C->CONSET & I2CONSET_SI));   // ȴʼźŷ
	// +ַֽ
   	LPC_I2C->DAT = CtrlAndAddr;	 // Ҫ͵ֽڸDATĴ
   	LPC_I2C->CONCLR = I2CONCLR_STAC | I2CONCLR_SIC; // ʼSTARTλSIλ 
   	while(!(LPC_I2C->CONSET & I2CONSET_SI));  // ȴݷ
   	if(LPC_I2C->STAT != res)	  // ۲STATĴӦ״̬жǷȷִжд
   	{
      	I2C_Stop();		 // û񣬷ֹͣźţI2Cͨ
      	return 1;			 // 1ʧܣ
   	}
   	return 0;			 // ȷִз0
}
/***************************************************/
/* ܣI2Cһֽ                     */
/* ڲsebyte : Ҫ͵ֽ                 */
/***************************************************/
void I2C_Send_Byte(uint8_t sebyte)
{
   LPC_I2C->DAT = sebyte;	  // ֽдDATĴ
   LPC_I2C->CONCLR = I2CONSET_SI;   // SI־
   while(!(LPC_I2C->CONSET & I2CONSET_SI));  // ȴݷ
}

/***************************************************/
/* ܣI2Cһֽ                     */
/* ڲrebyte : Ҫյֽ                 */
/***************************************************/
uint8_t I2C_Recieve_Byte(void)
{
	uint8_t rebyte;
	
	LPC_I2C->CONCLR = I2CONCLR_AAC | I2CONCLR_SIC;  // AASI־
	while(!(LPC_I2C->CONSET & I2CONSET_SI));  // ȴ
	rebyte = (uint8_t)LPC_I2C->DAT;	// ѽյݸrebyte

	return rebyte;
}


