#ifndef __SD_H_
#define __SD_H_		 	 
#include <lpc11xx.h>
//SDݽǷͷߺ궨  
#define NO_RELEASE      0
#define RELEASE         1		 
// SDͶ  
#define SD_TYPE_MMC     0
#define SD_TYPE_V1      1
#define SD_TYPE_V2      2
#define SD_TYPE_V2HC    4	   
// SDָ  	   
#define CMD0    0       //λ
#define CMD1    1
#define CMD9    9       //9 CSD
#define CMD10   10      //10CID
#define CMD12   12      //12ֹͣݴ
#define CMD16   16      //16SectorSize Ӧ0x00
#define CMD17   17      //17sector
#define CMD18   18      //18Multi sector
#define ACMD23  23      //23ösectorдǰԤȲNblock
#define CMD24   24      //24дsector
#define CMD25   25      //25дMulti sector
#define ACMD41  41      //41Ӧ0x00
#define CMD55   55      //55Ӧ0x01
#define CMD58   58      //58OCRϢ
#define CMD59   59      //59ʹ/ֹCRCӦ0x00
//дӦ
#define MSD_DATA_OK                0x05
#define MSD_DATA_CRC_ERROR         0x0B
#define MSD_DATA_WRITE_ERROR       0x0D
#define MSD_DATA_OTHER_ERROR       0xFF
//SDӦ
#define MSD_RESPONSE_NO_ERROR      0x00
#define MSD_IN_IDLE_STATE          0x01
#define MSD_ERASE_RESET            0x02
#define MSD_ILLEGAL_COMMAND        0x04
#define MSD_COM_CRC_ERROR          0x08
#define MSD_ERASE_SEQUENCE_ERROR   0x10
#define MSD_ADDRESS_ERROR          0x20
#define MSD_PARAMETER_ERROR        0x40
#define MSD_RESPONSE_FAILURE       0xFF
 							   						 	 
//Mini LPC1114ʹõP1.5ΪSDCS.
#define	SD_CS_High  LPC_GPIO0->DATA|=(1<<2)  // SD_CS = 1;
#define SD_CS_Low   LPC_GPIO0->DATA&=~(1<<2)  // SD_CS = 0;					    	  

extern uint8_t  SD_Type;//SD
// 

uint8_t SD_SendCommand(uint8_t cmd, uint32_t arg, uint8_t crc);                 //SDһ
uint8_t SD_SendCommand_NoDeassert(uint8_t cmd, uint32_t arg, uint8_t crc);		//SDһ(Ƭѡ)
uint8_t SD_Init(void);                                                    //SDʼ

uint8_t SD_ReceiveData(uint8_t *data, uint16_t len, uint8_t release);           //SD
uint8_t SD_GetCID(uint8_t *cid_data);                                       //SDCID
uint8_t SD_GetCSD(uint8_t *csd_data);                                       //SDCSD
uint32_t SD_GetCapacity(void);                                            //ȡSD

uint8_t SD_ReadSingleBlock(uint32_t sector, uint8_t *buffer);                 //һBLOCK
uint8_t SD_WriteSingleBlock(uint32_t sector, const uint8_t *buffer); 		    //дһBLOCK
uint8_t SD_ReadMultiBlock(uint32_t sector, uint8_t *buffer, uint8_t count); 	//BLOCK
uint8_t SD_WriteMultiBlock(uint32_t sector, const uint8_t *data, uint8_t count);//дBLOCK

#endif






