#include "lpc11xx.h"
#include "NRF24L01.h"
#include "uart.h"
#include "timer32.h"
#include "ssp.h"
#include "stdio.h"

//#define Open_RX
#define Open_TX

extern uint8_t RX_BUF[];
extern uint8_t TX_BUF[];

int main(void)
{
	SystemInit();
	nRF24L01_Initial();

    UART_init(GENBPS);
	printf("UART OK!\r\n");


	while(1)
	{
		#ifdef Open_TX
			TX_BUF[0]=0x04;
			NRF24L01_Send();
			printf("\r\nSend data0x%x\r\n",TX_BUF[0]);
			TIM32B0_delay_ms(1000);
		#else
			NRF24L01_Receive();

		#endif
	}
}
