/*********************************************************************************************************
*
* File                : PS2.h
* Hardware Environment: 
* Build Environment   : RealView MDK-ARM Version:4.14
* Version             : V1.0
* By                  : Xiao xian hui
*
*                                  (c) Copyright 2005-2010, WaveShare
*                                       http://www.waveShare.net
*                                          All Rights Reserved
*
*********************************************************************************************************/

#ifndef _PS2_H
#define _PS2_H

#include <LPC11xx.h>
#include "gpio.h"
/*PS2_DATA->PIO1_4   PS2_CLK->PIO1_5*/



#define SET_SDA    LPC_GPIO1->DATA |= (1<<4); 		
#define CLR_SDA    LPC_GPIO1->DATA &= ~(1<<4);  			
#define GET_SDA    (LPC_GPIO1->DATA&(1<<4))     			

#define SET_SCK    LPC_GPIO1->DATA |= (1<<5);  			
#define CLR_SCK    LPC_GPIO1->DATA &= ~(1<<5);
#define GET_SCK	   (LPC_GPIO1->DATA&(1<<5))

   

void PS2_OUT_SDA(void);
void PS2_IN_SDA(void);
void PS2_OUT_SCK(void);
void PS2_IN_SCK(void);
void PS2_Init(void);
void check(void);
uint8_t keyHandle(uint8_t val);

#endif /*_PS2_H*/
